#include "stdafx.h"

//const char* insertFirst="insert into mymusic (music_time, music_size, music_name, music_signature, music_data) values (now()";
const char* insertFirst="insert into mypicture (picture_time, \
	picture_name, picture_signature, picture_data, picture_thumb, picture_image,\
	picture_size,picture_width, picture_height,\
	picture_image_width, picture_image_height, \
	picture_image_size, picture_thumb_size, picture_thumb_datasize) values (now(),";




FILE* MySqlHelper::log = NULL;



bool isPictureFile(TCHAR* namePtr)
{
	return      _tcsicmp(namePtr, _T("jpg"))==0||
				_tcsicmp(namePtr, _T("bmp"))==0 ;				
}


MySqlHelper::~MySqlHelper()
{  
	if (log != NULL)
	{
		fclose(log);
		log = NULL;
	}
}

bool MySqlHelper::getHostIp(char* buffer)
{
	WSADATA wsa_Data;
	char nameBuffer[256];
	char* ptr;
	bool result = false;
	struct hostent *host_entry;
	if (WSAStartup(0x101,&wsa_Data))
	{
		return false;
	}
	if (gethostname(nameBuffer, 255))
	{
		WSACleanup();
		return false;
	}

	if ((host_entry = gethostbyname(nameBuffer))!= NULL)
	{		
		if ((ptr = inet_ntoa(*((in_addr *)host_entry->h_addr_list[0]))) != NULL)
		{
			strcpy(buffer, ptr);
			result = true;			
		}			
	}
	WSACleanup();
	return result;
}




bool MySqlHelper::doSaveToFile(LPBYTE imagePtr, DWORD imageSize)
{
	bool result = false;
	int imageWidth;
	int imageHeight;
	int stretchedWidth;
	int stretchedHeight;
	LPBYTE thumbPtr;
	LPBYTE stretchedPtr;
	DWORD thumbDataSize;
	DWORD stretchedSize;
	ImageFileFormat fileFormat;	 

	fileFormat=imageFileFormat(imagePtr);
	if (imageProcess(imagePtr, imageSize, DefaultMaxHeight, DefaultThumbnailSize,
		imageWidth, imageHeight, stretchedWidth, stretchedHeight, thumbPtr, 
		stretchedPtr, thumbDataSize, stretchedSize) == JPEG_SUCCESS)
	{
		switch (fileFormat)
		{
		case Image_File_Format_BMP:
			saveJpgFile(_T("original.bmp"), imagePtr, imageSize);
			break;
		case Image_File_Format_JPG:
			break;
			saveJpgFile(_T("original.jpg"), imagePtr, imageSize);
			break;
		}
		saveJpgFile(_T("stretched.jpg"), stretchedPtr, stretchedSize);
		saveJpgFile(_T("thumbnail.jpg"), thumbPtr, thumbDataSize);
		_ftprintf(log, _T("imageSize[%d], maxHeight[%d],thumbSize[%d],imageWidth[%d],\
		  imageHeight[%d], stretchedWidth[%d], stretchedHeight[%d], thumbDataSize[%d],\
		  stretchedSize[%d]\n"), imageSize, DefaultMaxHeight, DefaultThumbnailSize,
		  imageWidth, imageHeight,
		  stretchedWidth, stretchedHeight, thumbDataSize, stretchedSize);
		free(stretchedPtr);
		free(thumbPtr);
		result = true;
	}
	return result;	
}


bool MySqlHelper::saveToFile(int offset)
{
	LPBYTE imagePtr;
	DWORD imageSize;
	bool result = false;

	int id;

	//id = minId + offset;
	id = offset;
	
	if (fetchData(id, imagePtr, imageSize))
	{
		result = doSaveToFile(imagePtr, imageSize);
		free(imagePtr);
	}
	return result;	
}


bool MySqlHelper::init(MYSQL* mySqlPtr)
{
	if (log == NULL)
	{
		if ((log = fopen("mysql.log", "a+"))==NULL)
		{
			return false;
		}
	}
	mysql = mySqlPtr;
 	return true;
}

 


bool MySqlHelper::fetchData(int id, LPBYTE& imagePtr, DWORD& imageSize)
{
	char buffer[256];
	MYSQL_ROW row;
	unsigned long * lengths;
	MYSQL_RES* res=NULL;	  

	sprintf(buffer, "select picture_data from mypicture where id = %d", id);

	if (doFetchResult(buffer, res))
	{	
		if ((row=mysql_fetch_row(res))==NULL)
		{
			_ftprintf(log, _T("row error %s\n"), mysql_error(mysql));
			mysql_free_result(res);
			return false;
		}  

		if ((lengths=mysql_fetch_lengths(res))==NULL)
		{
			_ftprintf(log, _T("row length error %s\n"), mysql_error(mysql));
			mysql_free_result(res);	 
			return false;
		}
		imageSize = lengths[0];
		imagePtr = (LPBYTE)malloc(imageSize);
		if (imagePtr == NULL)
		{
			_ftprintf(log, _T("allocate memory faile for %d bytes\n"), imageSize);
			mysql_free_result(res);	 
			return false;  
		}
		memcpy(imagePtr, row[0], imageSize);
		mysql_free_result(res);	
		return true;
	}
	return false;	 	
}


bool MySqlHelper::doFetchResult(const char* statement, MYSQL_RES*& res)
{
	if (mysql_real_query(mysql, statement, strlen(statement)))
	{
		_ftprintf(log, _T("query error %s\n"), mysql_error(mysql));	
		return false;
	}

	if ((res=mysql_store_result(mysql))==NULL)
	{
		_ftprintf(log, _T("store result error %s\n"), mysql_error(mysql));			
		return false;
	}
	return true;
}


bool MySqlHelper::updateInt(int id, int data, char* field, char* table)
{
	char buffer[256];
	sprintf(buffer, "update %s set %s=%d where %s = %d", table, field, data, "id", id);

	if (mysql_real_query(mysql, buffer, strlen(buffer)))
	{
		_ftprintf(log, _T("query error %s\n"), mysql_error(mysql));	
		return false;
	}
	return true;
}

bool MySqlHelper::updateBinary(int id, LPBYTE data, int size, char* field, char* table)
{
	char* buffer = NULL;
	int len, escapeLength;

	buffer = (char*)malloc(size*2 + 256);
	if (buffer == NULL)
	{
		return false;
	}
	sprintf(buffer, "update %s set %s =\"", table, field);
	len = strlen(buffer);
	if ((escapeLength = mysql_real_escape_string(mysql, buffer + len, (char*)data, size))
		==0)
	{
		free(buffer);
		return false;
	}
	len += escapeLength;
	sprintf(buffer+len, "\" where id = %d", id);
	len += strlen(buffer+len);

	if (mysql_real_query(mysql, buffer, len))
	{  
		_ftprintf(log, _T("query error %s\n"), mysql_error(mysql)); 		
		free(buffer);
		return false;
	}
	
	free(buffer);
	return true;
}


bool MySqlHelper::doInsertPicture(LPCTSTR fullName, const LPBYTE imagePtr, DWORD imageSize)
{
	int curBufferSize;
	unsigned char digest[16];
	int dataLength, firstLength;
	int imageWidth;
	int imageHeight;
	int stretchedWidth;
	int stretchedHeight;
	LPBYTE thumbPtr;
	LPBYTE stretchedPtr;
	DWORD thumbDataSize;
	DWORD stretchedSize; 
	bool hasError;
	char* tempBuffer = NULL;  

	hasError = true;
	if (imageProcess(imagePtr, imageSize, DefaultMaxHeight, DefaultThumbnailSize,
		imageWidth, imageHeight, stretchedWidth, stretchedHeight, thumbPtr, 
		stretchedPtr, thumbDataSize, stretchedSize) == JPEG_SUCCESS)
	{ 
		curBufferSize = imageSize * 2 + stretchedSize * 2 + 1024;
	
		if ((tempBuffer = (char*)malloc(curBufferSize)) != NULL)
		{	 	
			sprintf(tempBuffer, "%s", insertFirst);
			firstLength=strlen(tempBuffer);	

			calculateMD5((unsigned char*)imagePtr, imageSize, digest);	 					

			assembleEscapeStr(tempBuffer, (char*)fullName, _tcsclen(fullName)*sizeof(TCHAR), firstLength);
			assembleEscapeStr(tempBuffer, (char*)digest, 16, firstLength);	
			
			assembleEscapeStr(tempBuffer, (char*)imagePtr, imageSize, firstLength);

			assembleEscapeStr(tempBuffer, (char*)thumbPtr, thumbDataSize, firstLength);

			assembleEscapeStr(tempBuffer, (char*)stretchedPtr, stretchedSize, firstLength);
		
			sprintf(tempBuffer + firstLength, "%d,%d,%d,%d,%d,%d,%d,%d)", imageSize,
				imageWidth, imageHeight, stretchedWidth, stretchedHeight, 
				thumbDataSize, stretchedSize, DefaultThumbnailSize);
			dataLength = strlen(tempBuffer + firstLength);
			firstLength += dataLength;

			if (mysql_real_query(mysql, tempBuffer, firstLength))
			{
				printf("MySqlHelper insert picture query error %s\n", 
					mysql_error(mysql));				
										
				fflush(log);  					
			}
			else
			{	 	
				hasError = false; 
				_tprintf(_T("MySqlHelper insert picture succeeded \n"));			
			} 
			free(tempBuffer);
		}
		free(thumbPtr);
		free(stretchedPtr);
	}  		
	
	fflush(log);
	return !hasError;
}



void MySqlHelper::assembleEscapeStr(char* dest, const char* src, int srcSize, 
								   int& firstLength)
{
	int dataLength;
	dest[firstLength++]='"';	

	dataLength = mysql_real_escape_string(mysql, 
		dest + firstLength, src, srcSize);

	firstLength += dataLength;
	dest[firstLength++]='"'; 	
	dest[firstLength++]=',';
}
	

		








